;------------------------------- MIERNIK POJEMNOSCI CX-2a EdW ---------------------------

;Date		12 luty 2004r.			
;Device 		AT89C2051, X=24MHz 	
;Designer		Roman Biadalski
;Company	EdW	
		
;--------------------------- USTAWIENIA / ETYKIETY ----------------------------

BRIGHTLY_LED	equ	50
TIME_CALL	equ	5	;czas trwania procesu kalibracji 
TIME_ER		equ	5
TIME_IMP	equ	5	
DISPLAY_1	equ 	P3.5 	;lsb
DISPLAY_2   	equ	P3.7
DiSPLAY_3   	equ	P3.1
DISPLAY_4   	equ	P3.0	;usb
IN_1		equ	P3.4	;wejscie przerwan zewnecznych
IN_2		equ	P3.2	;wejscie licznika zewnecznego
RELAY		equ	P3.3	;sterowanie przekaznikiem - H/off i L/on 
GATE		equ 	33		
START_TIMER	equ	01010101B	
STOP_TIMER	equ	00000001B
TMOD_SET	equ	00010101B	
TH0_SET		equ	0		
TL0_SET		equ	0	
TH1_SET		equ	50
TL1_SET		equ	100		
STOS		equ 	60H	;wysokosc stosu		
IN_DISPLAY  	equ  	30H    	
MEMORY_B	equ	2BH
MEMORY_A	equ 	2AH	
TIME_RANGE	equ     	29H	
INDICATOR_IMP	equ	28H	
MNO1		equ	27H	
MNO2		equ	26H	
MNO3		equ	25H	
MODE		equ	24H
CHANGE    	equ	23H	
METER_T0 	equ  	22H    	
METER_T1      	equ  	21H 	
CORRECTION_1L  equ  	20H	
CORRECTION_1H 	equ  	1FH   	
CORRECTION_2L	equ  	1EH   	
CORRECTION_2H	equ  	1DH    	
METER_TIME_CA	equ  	1CH
METER_TIME_Er 	equ  	1BH    
INDICATOR_DOT	equ     	1AH	;wskaznik
WYN1		equ	18H
WYN2		equ	17H	
WYN3		equ  	16H
WYN4		equ	15H	
WYN5		equ	14H	
DOD1		equ	13H
DOD2		equ 	12H
DOD3		equ	11H
DOD4		equ	10H	
MAT1		equ	0FH
MAT2		equ	0EH
MAT3		equ	0DH
MAT4		equ	0CH
MAT5		equ	0BH
MAT6		equ	0AH
MAT7		equ	9H
MAT8		equ	8H  
r0reg 		equ 	8
r4reg 		equ 	12
r5reg 		equ 	13
r6reg 		equ 	14

LJMP START
org 03H	
	mov TCON,change		
	clr EX0		
	inc mode			
	reti
org 0BH	
	push psw
	inc meter_T0		
	pop psw
	reti
org 01BH	
	push psw
	push acc
		inc meter_T1		
		mov a,meter_T1
		cjne a,#0,_count_1a	
		mov meter_time_Er,#Time_Er	
	_count_1a:cjne a,#66,_count_1c	
		jnb RELAY,_count_1b
		mov meter_T1,#0	
		mov meter_T0,#0	
	_count_1b:clr RELAY	
	_count_1c:cjne a,#gate,_count_1d	
		clr IE0				
		mov change,#stop_timer	
 		setb EX0			
		jmp _count_1e		
	_count_1d:
		cjne a,#15,_count_1e
		mov indicator_dot,#0	;wyzerowanie wskaznika_ukonczenia pomiaru
	_count_1e:
	pop acc
	pop psw 	
	reti
	org 100
START:  mov sp,#stos          	;ustaw stos  
	clr a			;zeruj akumulatot 
    	mov b,a              		;zeruj rejestr B 
	setb IN_1			;ustaw jako wejscie
	setb IN_2			;ustaw jako wejscie
	setb RELAY		;wylacz przekaznik - zakres niski ( do 1uF ) 
	mov tmod,#tmod_set	;ustaw rejestry
	mov th0,#th0_set
	mov tl0,#tl0_set 	
	mov th1,#th1_set 	
	mov tl1,#tl1_set
	mov meter_T0,#0
	mov meter_T1,#0
;BANK0
CLR RS0
	setb et1				;zezwolenie na przerw. od przepelniena
	setb et0				;
	setb ea				;ogulne zezwolenie na przerwania  
	mov meter_time_CA,#Time_call	;wlacz kalibracje 	
	sjmp _start_bis			;
BEGIN:	mov a,mode			
	cjne a,#2,_omit_1 			
	mov indicator_dot,#1		
	LCALL _calculate		
	mov a,meter_time_CA		;warunek 
	cjne a,#0,_range_off		
	jnb RELAY,_range_high 		
	mov a,r7			
	mov b,#2				
	div ab
	jz _histereza			
	sjmp _on_low			;pozostan w niskim zakresie
_histereza:sjmp _count_high
_range_high:
	mov a,r7
	mov b,#6				
	div ab
	jz _on_high 
	sjmp _count_low
_count_high:djnz time_range,_range_off
	clr RELAY
_on_high:	mov time_range,#3	;3
	sjmp _range_off
_count_low:djnz time_range,_range_off
	setb RELAY
_on_low:	mov time_range,#3	;3
_range_off:				
_start_bis:mov TL0,#TL0_set		;zeruj licznik T0 - licznik impulsow zewnecznych
	mov TH0,#TH0_set
	mov meter_T0,#0
	mov TL1,#TL1_set		;ustaw tajmer T1 - licznik impulsow wzorcowych
	mov TH1,#TH1_set
	mov meter_T1,#0
	mov MEMORY_A,#255		
	mov MEMORY_B,#Time_IMP
	mov mode,#0		
	mov change,#start_timer	
	setb EX0			
_omit_1:	LCALL BinBcd32       	
	mov r0,#IN_DISPLAY	
	mov r1,#wyn5	
	mov r2,#5		
_petla:	mov a,@r1
	anl a,#0f0h		;maska 11110000
	swap a			;wymien polbajty w akumulatorze
	mov @r0,a
	inc r0
	mov a,@r1
	anl a,#0fh			;maska 00001111
	mov @r0,a
	inc r0
	inc r1
	djnz r2,_petla
	mov in_display+10,#10
	mov in_display+11,#10	
	mov in_display+12,#10	
	mov in_display+15,r7	
	mov a,meter_time_CA
	cjne a,#0,_on_napis_CA		
	sjmp _off_napis_CA
_on_napis_CA:
	mov in_display,#10	
	mov in_display+1,#13	
	mov in_display+2,#11
	mov in_display+3,#10	
	mov meter_time_Er,#0 		
_off_napis_CA:
	mov a,meter_time_Er		
	cjne a,#0,_on_napis_Er		
	sjmp _off_napis_Er
_on_napis_Er:
	mov in_display,#10		
	mov in_display+1,#11	
	mov in_display+2,#12
	mov in_display+3,#10	
_off_napis_Er:
_loop_p:	mov r0,#in_display     		
        	mov r2,#4		        	
	mov r7,#0			
_loop:	orl P3,#10100011B			
	cjne r2,#4,_ski_1			
	mov dptr,#_cod_display_2		
	clr DISPLAY_4			
_ski_1:	cjne r2,#3,_ski_2			
        	mov dptr,#_cod_display_1		
	clr DISPLAY_3			
_ski_2:	cjne r2,#2,_ski_3			
        	mov dptr,#_cod_display_2		
	clr DISPLAY_2			
_ski_3:	cjne r2,#1,_ski_4			
	jnb RELAY,_change_cod	
        	mov dptr,#_cod_low_c		
	sjmp _cod_low		
_change_cod:				
	mov dptr,#_cod_high_c	
_cod_low:mov r0,#in_display+15		
	clr DISPLAY_1			
;########################
sjmp _ski_4					
_loop_x:				
ljmp _loop
;########################	
_ski_4:	mov a,@r0		;kod aktualnego wyswietlacza
        	inc r0                     
	jb DISPLAY_4,_zero2	
	cjne a,#0,_zero_piko
	mov r5,#1	
	inc r7		
	jmp _ski_4	
_zero_piko:cjne r7,#9,_zero5	   
	dec r0                     	
	dec r0                     	
	mov a,@r0                  	
_zero2:	jb DISPLAY_3,_zero3	
	cjne a,#0,_zero5           
	cjne r5,#1,_zero5
	mov r5,#1
	jmp _ski_4
_zero3:	jb DISPLAY_2,_zero_on
	cjne a,#0,_zero5           
	cjne r5,#1,_zero5
	mov r5,#1
	jmp _ski_4
_zero5:	mov r5,#0
_zero_on:	movc a,@a+dptr             ;pobranie kodu znaku
	jb DISPLAY_4,_dot_2	
	cjne r7,#2,_dot_1a	
	anl a,#10111111b		
_dot_1a:	cjne r7,#5,_dot_1b
	anl a,#10111111b
_dot_1b:	cjne r7,#8,_dot_1c
	anl a,#10111111b
_dot_1c:	cjne r7,#9,_dot_1d
	anl a,#10111111b
_dot_1d:	cjne r7,#11,_dot_end
	anl a,#10111111b
_dot_2:	jb DISPLAY_3,_dot_4	
	cjne r7,#1,_dot_2a		
	anl a,#11110111b		
_dot_2a:	cjne r7,#4,_dot_2b
	anl a,#11110111b
_dot_2b:	cjne r7,#7,_dot_2c
	anl a,#11110111b
_dot_2c:	cjne r7,#11,_dot_end
	anl a,#11110111b	
_dot_4:	jb DISPLAY_1,_dot_end
	mov r6,indicator_dot
	cjne r6,#1,_dot_end
	anl a,#11110111b
_dot_END:	
	mov P1,a	 			;wpis znaku na wyswietlacz
        	mov r4,#Brightly_LED		
        	djnz r4,$				
        	mov p1,#11111111b      	
        	djnz r2,_loop_x         		
	jnb RELAY,_end_lack_imp		
	mov a,tl1			
	cjne a,indicator_imp,_end_imp
	djnz MEMORY_A,_end_imp		
	DJNZ MEMORY_B,_END_IMP	
	clr RELAY 			
_end_imp:mov indicator_imp,tl1	
_end_lack_imp:
 LJMP BEGIN				
BinBcd32:
     push psw           	
     push b
     push acc
 	mov wyn1,#0        	;wyzerowanie wyniku
	mov wyn2,#0
	mov wyn3,#0
	mov wyn4,#0                                                     
	mov wyn5,#0	
	mov r0,#1
	mov r1,#32         
	mov dptr,#tabl    	
	mov r4,#0          	
	mov r2,dod1    	
	again:                  	
	cjne r4,#8,kon1
	mov r2,dod2        	
	kon1:
	cjne r4,#16,kon2	
	mov r2,dod3        	
	kon2:
	cjne r4,#24,ioD
	mov r2,dod4 		
	ioD:
             	inc r4
	mov a,r2
	anl a,r0           	
	jz fini_1          
	mov a,r1           	
	dec a              	
	mov b,#5           	
	mul ab             	
	mov r3,a
	inc a              
	inc a
	inc a
	inc a
	movc a,@a+dptr     
	add a,wyn1         	
	da a               
	mov wyn1,a
	jnc poC            	
	mov a,wyn2         	
	add a,#1
	da a               	
	mov wyn2,a
	jnc poC
	mov a,wyn3         	
	add a,#1           	
	mov wyn3,a
	jnc poC
	mov a,wyn4
	add a,#1
	mov wyn4,a
	jnC poC
               mov a,wyn5
	add a,#1
 	mov wyn5,a
poC:	mov a,r3
	inc a         
	inc a	  
               inc a
	movc a,@a+dptr
	jz fini_1
	add a,wyn2
	da a
	mov wyn2,a
	jnc poC2
	mov a,wyn3
	add a,#1     
	mov wyn3,a
	jnc poC2
	mov a,wyn4
	add a,#1
	mov wyn4,a
	jnC poC2
	mov a,wyn5
	add a,#1
	mov wyn5,a
FINI_1:    ljmp fini
AGAIN_1:ljmp again
poC2:	mov a,r3
	inc a
               inc a		 
	movc a,@a+dptr
	jz fini
	add a,wyn3
	da a
	mov wyn3,a
	jnc poC3
	mov a,wyn4
	add a,#1
	mov wyn4,a
	jnC poC3		
	mov a,wyn5
	add a,#1
	mov wyn5,a		
poC3:	mov a,r3
	inc a
	movc a,@a+dptr
	jz fini
	add a,wyn4
	da a
	mov wyn4,a
	jnC poC4	
	mov a,wyn5
               add a,#1
               da a
               mov wyn5,a
poC4:      mov a,r3
               movc a,@a+dptr
               jz fini
	add a,wyn5
	mov wyn5,a
fini:    	mov a,r0               
	rl a                  	
	mov r0,a
	djnz r1,again_1       	
pop acc               	   	
pop b
pop psw
RET 
_CALCULATE:
push PSW
push B
push ACC
SETB RS0
	mov dod1,TL1		
	mov dod2,TH1		
	mov dod3,meter_T1
	mov dod4,#0
	mov r1,#10		
	mov r0,#dod1		
	mov a,@r0
	mov b,r1
	mul ab		
	mov r2,a			
	mov r3,b	
	dec r0
	mov a,@r0
	mov b,r1
	mul ab			
	add a,r3	
	mov r3,a		
	clr a
	addc a,b
	mov r4,a			
	clr a			
	addc a,#0
	mov r5,a		
	dec r0
	mov a,@r0
	mov b,r1
	mul ab			
	add a,R4
	mov r4,a			
	mov a,r5	
	addc a,b
	mov r5,a			
	mov dod1,r2
	mov dod2,r3
	mov dod3,r4
	mov dod4,r5	
	clr c
	mov a,TL0
	rlc a
	mov TL0,a
	mov a,TH0  
	rlc a
	mov TH0,a
	mov a,meter_T0
	rlc a
	mov meter_T0,a
	clr c
	mov mno1,TL0	        	
	mov mno2,TH0	        
	mov mno3,meter_T0	
	mov r0,#dod4	
	mov r1,#mno3	
dziel32_16:clr a		
	mov r4,a
	mov r5,a			
	mov r6,a
	mov r7,#33	
	mov a,@r1	
	inc r1
	orl a,@r1
	inc r1
	orl a,@r1
	dec r1
	dec r1
	jz dziel32_7x	
	ljmp dziel32_1	
	dziel32_2:
	push r6reg
	push r5reg		
	push r4reg
	inc r1
	inc r1
	mov a,r4			
	clr c			
	subb a,@r1		
	mov r4,a		
	dec r1
	mov a,r5
	subb a,@r1
	mov r5,a
	dec r1
	mov a,r6
	subb a,@r1
	mov r6,a
	jnc dziel32_3		
	pop r4reg		
	pop r5reg
	pop r6reg
;#######################################
	ajmp dziel32_1
dziel32_2x:
	ljmp dziel32_2
dziel32_7x:
	ljmp dziel32_7
;#######################################
dziel32_1:mov a,#3	
	add a,r0
	mov r0,a
	mov a,@r0	
	add a,@r0	
	mov @r0,a	
	dec r0		
	mov a,@r0	
	addc a,@r0	
	mov @r0,a	
	dec r0		
	mov a,@r0	
	addc a,@r0	
	mov @r0,a	
	dec r0		
	mov a,@r0
	addc a,@r0
	mov @r0,a
	push psw
	mov a,r4		
	add a,r4	
	mov r4,a		
	mov a,r5
	addc a,r5
	mov r5,a
	mov a,r6
	addc a,r6
	mov r6,a	
	pop psw
	jnc dziel32_10
	inc r4
dziel32_10:djnz r7,dziel32_2	
	clr c		
	mov a,r6
	rrc a
	mov r6,a
	mov a,r5
	rrc a
	mov r5,a
 	mov a,r4			
	rrc a			
	mov r4,a			
	ljmp dane_dz	
dziel32_3:pop acc
	pop acc	
	pop acc		
	mov a,#3		
	add a,r0
	mov r0,a
	mov a,@r0		
	add a,@r0		
	mov @r0,a		
	dec r0	
	mov a,@r0		
	addc a,@r0		
	mov @r0,a		
	dec r0			
	mov a,@r0		
	addc a,@r0		
	mov @r0,a		
	dec r0		
	mov a,@r0
	addc a,@r0
	mov @r0,a
	push psw
	mov a,r4		
	add a,r4
	mov r4,a			
	mov a,r5
	addc a,r5
	mov r5,a
	mov a,r6
	addc a,r6
	mov r6,a
	pop psw
	jnc dziel32_9
	inc r4
dziel32_9:push r0reg		
	inc r0			;modyfikacja wskaznika adresowego , R0+1
	inc r0			;R0+1
	inc r0			;R0+1
	inc @r0			;inkrementuj bajt adresowany przez R0
	pop r0reg		
dziel32_4:djnz r7,dziel32_2x		
	clr c			
	mov a,r6
	rrc a
	mov r6,a
	mov a,r5
	rrc a
	mov r5,a
	mov a,r4			
	rrc a		
	mov r4,a			
	ljmp dane_dz
dziel32_7:setb psw.2	
dane_dz:	mov a,meter_time_CA	
	cjne a,#0,_on_call		
	sjmp _of_call 		
_on_call:	dec a			
	mov meter_time_CA,a
	cjne a,#1,_trwa_call_1	
	mov correction_1L,dod1	
	mov correction_1H,dod2	
_trwa_call_1:sjmp _omit_call		
_of_call:	jnb RELAY,_second_range  	
	mov mat4,#0 	
	mov mat3,#0	
	mov mat2,correction_1H	
	mov mat1,correction_1L	
	mov r0,#dod1		
	mov r1,#mat1		
	mov r2,#4		
	clr c			
sub1:	mov a,@r0
	subb a,@r1
	mov @r0,a
	dec r0
	dec r1
	djnz r2,sub1
	mov a,dod4
	cjne a,#255,_second_range
	mov mat4,#0
	mov mat3,#0
	mov mat2,#0
	mov mat1,#2
	mov r0,#dod1	
	mov r1,#mat1	
	mov r2,#4	
	clr c
ad1:	mov a,@r0
	addc a,@r1
	mov @r0,a
	dec r0
	dec r1
	djnz r2,ad1
_second_range:
	mov a,meter_time_Er
	cjne a,#0,_aga
	sjmp _omit_call
_aga:	dec meter_time_Er
_omit_call:CLR RS0		
	pop ACC
	pop B
	pop PSW
	RET
_COD_DISPLAY_1:
              	db     00101000b       	;kod znaku 0 
              	db     11101011b       	
              	db     00011001b       
              	db     01001001b       	
              	db     11001010b       	
              	db     01001100b       
 	db     00001100b       	
             	db     11101001b       	
              	db     00001000b       	
              	db     01001000b       	;kod znaku 9 
	db     11011111b       	; -	10
	db     00011100b       	;E	11
	db     00111110b      	;L	12
	db     00111100b       	;C    	13
_COD_DISPLAY_2:
              	db     01000100b       	;kod znaku 0 
              	db     01111110b       	;kod znaku 1 
             	db     11001000b       	;kod znaku 2 
             	db     01011000b       	;kod znaku 3 
             	db     01110010b       	;kod znaku 4 
             	db     01010001b       	;kod znaku 5 
            	db     01000001b       	;kod znaku 6 
             	db     01111100b      	;kod znaku 7 
              	db     01000000b       	;kod znaku 8 
             	db     01010000b       	;kod znaku 9 
	db     11111011b       	; -	10
	db     01100000b       	;A 	11	
	db     11101011b       	;r	12
_COD_LOW_C:	
	db     11011111b		;-			
	db     00101111b    		;u
	db     00101111b       	;u	
	db     10001111b        	;n
	db     10001111b        	;n	
	db     10001111b        	;n	
	db     10011000b        	;P
	db     10011000b        	;P	
	db     10011000b        	;P	
	db     10011000b        	;P
	db     00011111b        	;c			
	db     10011111b        	;r			
	db     10011111b        	;r	12	
_COD_HIGH_C:
	db     11011111b		;-			
	db     00001111b		;o	
	db     00001111b		;o	
	db     00101111b		;u     	
	db     00101111b		;u     	
	db     00101111b		;u   	
	db     10001111b        	;n	
	db     10001111b        	;n
	db     10001111b        	;n	
	db     10011000b        	;P	
	db     10011000b        	;P	
	db     10011000b        	;P
	db     10011111b		;r	12
;----------------------------------------------------------------------
tabl: 	db 21h,47h,48h,36h,48h
	db 10h,73h,74h,18h,24h	
	db 05h,36h,87h,09h,12h	
	db 02h,68h,43h,54h,56h	
	db 01h,34h,21h,77h,28h	
	db 00h,67h,10h,88h,64h	
	db 00h,33h,55h,44h,32h
	db 00h,16h,77h,72h,16h	
	db 00h,08h,38h,86h,08h        	
              	db 00h,04h,19h,43h,04h        
             	db 00h,02h,09h,71h,52h         
              	db 00h,01h,04h,85h,76h         
              	db 00h,00h,52h,42h,88h        
              	db 00h,00h,26h,21h,44h         
              	db 00h,00h,13h,10h,72h         
              	db 00h,00h,06h,55h,36h         
              	db 00h,00h,03h,27h,68h         
              	db 00h,00h,01h,63h,84h         
              	db 00h,00h,00h,81h,92h         
              	db 00h,00h,00h,40h,96h         
              	db 00h,00h,00h,20h,48h         
              	db 00h,00h,00h,10h,24h         
              	db 00h,00h,00h,05h,12h         
              	db 00h,00h,00h,02h,56h         
              	db 00h,00h,00h,01h,28h         
              	db 00h,00h,00h,00h,64h         
              	db 00h,00h,00h,00h,32h         
              	db 00h,00h,00h,00h,16h         
              	db 00h,00h,00h,00h,08h         
              	db 00h,00h,00h,00h,04h         
              	db 00h,00h,00h,00h,02h         
              	db 00h,00h,00h,00h,01h         
;----------------------------------------------------------------------
END.	
